/* (C) Collabora Productivity 2020, All Rights Reserved */
var brandProductName = 'Nextcloud Office';
var brandProductURL = 'https://nextcloud.com/office';
var brandProductFAQURL = 'https://nextcloud.com/office';

var menuItems;
var applyBranding = function() {
	// wait until the menu (and particularly the document-header) actually exists
	function setLogo() {
		var logoHeader = document.getElementById('document-header');
		if (!logoHeader) {
			// the logo does not exist in the menu yet, re-try in 250ms
			setTimeout(setLogo, 250);
		} else {
			var logo = $('#document-header > div');
			logo.attr('title', '');

			// Handle click on logo
			logo.off('click').on('click', function(e) {
				onClose(e);
			 });

			menuItems = document.querySelectorAll('#main-menu > li > a');

			var customLogo = getComputedStyle(document.documentElement).getPropertyValue('--nc-custom-logo');
			if (customLogo !== '') {
				var logoUrl = window.docURL.substr(0, window.docURL.indexOf('/apps/richdocuments/wopi/')) + '/apps/theming/image/logo?v=' + customLogo;
				document.documentElement.style.setProperty('--co-image-logo', 'url(' + logoUrl + ')');
			}
		}
	}

	function setAboutImg() {
		if (document.getElementById('lokit-extra'))
			return;
		var lk = document.getElementById('lokit-version');
		var aboutDialog = document.getElementById('about-dialog-info');
		if (!lk || !aboutDialog) {
			setTimeout(setAboutImg, 250);
		} else {
			lk = lk.parentNode;
			lk.insertAdjacentHTML('beforebegin', '<div style="margin-inline-end: auto;" id="lokit-extra"><span dir="ltr">built on&nbsp;<a href="javascript:void(window.open(\'http://col.la/lot\'));">a great technology base</a></span></div>');
		}
	}

	function addShareButton() {
		if (!L.Map.THIS.wopi.EnableShare || document.getElementById('icon-nextcloud-sidebar')) {
			return;
		}

		var closeButton = document.getElementById('closebuttonwrapper');
		var share = document.createElement('button');
		share.id = 'icon-nextcloud-sidebar';
		share.classList = 'icon-nextcloud-sidebar';
		share.setAttribute('aria-label',_('Share'));
		share.setAttribute('title',_('Share'));
		share.addEventListener('click', function() {
			L.Map.THIS.openShare();
		});
		closeButton.parentNode.insertBefore(share, closeButton);
	}

	function cssUrlsRenamerSocketProxy() {
		var replaceUrls = function(rules, replaceBase) {
			if (!rules)
				return;

			for (var r = 0; r < rules.length; ++r) {
				// check subset of rules like @media or @import
				if (rules[r] && rules[r].type != 1) {
					replaceUrls(rules[r].cssRules || rules[r].rules, replaceBase);
					continue;
				}
				if (!rules[r] || !rules[r].style)
					continue;
				var img = rules[r].style.backgroundImage;
				if (img === '' || img === undefined)
					continue;
				if (img.startsWith('url("images/'))
				{
					rules[r].style.backgroundImage =
						img.replace('url("images/', replaceBase + '/images/');
				}
				if (img.startsWith('url("remote/'))
				{
					rules[r].style.backgroundImage =
						img.replace('url("remote/', replaceBase + '/remote/');
				}
			}
		};
		var sheets = document.styleSheets;
		for (var i = 0; i < sheets.length; ++i) {
			var relBases;
			try {
				relBases = sheets[i].href.split('/');
			} catch {
				window.app.console.log('Missing href from CSS number ' + i);
				continue;
			}
			relBases.pop(); // bin last - css name.
			var replaceBase = 'url("' + relBases.join('/');

			var rules;
			try {
				rules = sheets[i].cssRules || sheets[i].rules;
			} catch (err) {
				window.app.console.log('Missing CSS from ' + sheets[i].href);
				continue;
			}
			replaceUrls(rules, replaceBase);
		}
	};

	addShareButton();
	setLogo();
	setAboutImg();

	if (window.socketProxy) {
		cssUrlsRenamerSocketProxy();
	}
};

window.addEventListener('load', applyBranding);
window.initializedUI = applyBranding; // will be called on UI init (also after mode switch)

/*a::first-letter"*/
document.onkeyup = function(e) {
	if (e.altKey && e.shiftKey) {
		console.log('alt + shift + f');
		menuItems.forEach(function(menuItem) {
			menuItem.style.setProperty('text-decoration', 'underline', 'important');
		});
	}
};
